'Windows ME, 2000, XP, 2003, Vista, 2008 or 98/NT 4 with Windows Management Instrumentation (WMI)


'-----------------------------------------------------------------------------------------------------------------------------------------------------
Option Explicit
On Error Resume Next



'-----------------------------------------------------------------------------------------------------------------------------------------------------
Const KS_APP_NAME = "FreeMem"
Const KI_APP_MAJOR = 1
Const KI_APP_MINOR = 10
Const KI_APP_BUILD = 22



'-----------------------------------------------------------------------------------------------------------------------------------------------------
Dim giInitialMb, giEndMb
Dim gbSilent, gbNoProcess, gbNoMemory




'-----------------------------------------------------------------------------------------------------------------------------------------------------
gbSilent = False
gbNoProcess = False
gbNoMemory = False
giInitialMb = GetFreeMemory

ParseCommandLine

If Not gbSilent Then
	MsgBox KS_APP_NAME & " v" & KI_APP_MAJOR & "." & KI_APP_MINOR & " build " & KI_APP_BUILD & ". A simple memory defragmenter and process optimizer." & vbCrLf & _
		"Copyright (c) 2008 by Javier Gutirrez Chamorro" & vbCrLf & _
		"http://nikkhokkho.sourceforge.net/static.php?page=FreeMem" & vbCrLf & vbCrLf & _
		KS_APP_NAME & " is a Windows script designed to defragment your RAM memory by paging-in all your running process, and optimize the running applications." & vbCrLf & _
		"To start it, simply double click on the " & KS_APP_NAME & ".vbe file." & vbCrLf & vbCrLf & _
		"Optionally you can specify the following command-line switches:" & vbCrLf & _
		"/NOPROCESS: Skip idle process optimization." & vbCrLf & _
		"/NOMEMORY: Skip memory defragmentation." & vbCrLf & _
		"/SILENT: Skip welcome" & vbCrLf & vbCrLf & _
		"For instance running '" & KS_APP_NAME & ".vbe /NOPROCESS /SILENT' will directly execute a memory defragmentation everytime it is launched. For your convenience, you can create a shortcut with your desired parameters, so it is ready to be invoked.", _
		0+64, KS_APP_NAME
End If

If Not gbNoMemory Then
	If MsgBox("Do you want to run memory defragmention now?" & vbCrLf & vbCrLf & _
		"Defragmentation can take up to 1 minute, and make your system respond slowly.", 4+32, KS_APP_NAME) = 6 Then
		CommitMemory GetTotalMemory * 4 \ 5
	Else
		gbNoMemory = True
	End If
End If

If Not gbNoProcess Then
	If MsgBox("Do you want to run process optimization?" & vbCrLf & vbCrLf & _
		"Process optimization runs in the background, and can take up to 15 minutes.", 4+32, KS_APP_NAME) = 6 Then
		ProcessIdle
	Else
		gbNoProcess = True
	End If
End If

giEndMb = GetFreeMemory

If Not gbNoMemory Then
	MsgBox "FreeMem has finished optimized your memory!" & vbCrLf & _
		"It has been able to save you " & (giEndMb - giInitialMb) & " Mb. of free RAM." & vbCrLf & vbCrLf & _
		"- Memory free at start: " & giInitialMb & " Mb." & vbCrLf & _
		"- Memory free now: " & giEndMb & " Mb.", 64+4096, _
		KS_APP_NAME
End If



'-----------------------------------------------------------------------------------------------------------------------------------------------------
Sub ParseCommandLine()
	Dim clnResult, sResult


	Set clnResult = WScript.Arguments
	For Each sResult In clnResult
		If Left("/SILENT", Len(sResult)) = UCase(sResult) Then
			gbSilent = True
		ElseIf Left("/NOMEMORY", Len(sResult)) = UCase(sResult) Then
			gbNoMemory = True
		ElseIf Left("/NOPROCESS", Len(sResult)) = UCase(sResult) Then
			gbNoProcess = True
		End If
	Next
	Set sResult = Nothing
	Set clnResult = Nothing 
End Sub



'-----------------------------------------------------------------------------------------------------------------------------------------------------
Function GetFreeMemory()
	Dim oWmi, clnResult, oResult
	Dim oRefresher


	GetFreeMemory = 1
	Set oWmi = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2") 
	Set oRefresher = CreateObject("WbemScripting.SWbemRefresher")
	Set clnResult = oRefresher.AddEnum(oWmi, "Win32_PerfFormattedData_PerfOS_Memory").objectSet
	oRefresher.Refresh
	For Each oResult In clnResult
		GetFreeMemory = oResult.AvailableMBytes
	Next
	Set oResult = Nothing
	Set clnResult = Nothing
	Set oRefresher = Nothing
	Set oWmi = Nothing
End Function



'-----------------------------------------------------------------------------------------------------------------------------------------------------
Function GetTotalMemory()
	Dim oWmi, clnResult, oResult

	GetTotalMemory = 1
	Set oWmi = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\cimv2") 
	Set clnResult = oWmi.ExecQuery("SELECT TotalPhysicalMemory FROM Win32_ComputerSystem")
	For Each oResult In clnResult
		GetTotalMemory = oResult.TotalPhysicalMemory
	Next
	Set oResult = Nothing
	Set clnResult = Nothing
	Set oWmi = Nothing
End Function



'-----------------------------------------------------------------------------------------------------------------------------------------------------
Sub ProcessIdle()
	Dim oShell
	'Freeup resources from idle tasks in background
	Set oShell = CreateObject("Wscript.Shell") 
	oShell.Run "rundll32.exe advapi32.dll,ProcessIdleTasks", 0, False	'http://msdn2.microsoft.com/en-us/library/d5fk67ky(VS.85).aspx
	Set oShell = Nothing
End Sub


'-----------------------------------------------------------------------------------------------------------------------------------------------------
Sub CommitMemory(piMemory)
	'Commit memory by reserving the required 16 byte items
	Dim iCount, iMemory16
	Dim avBlock()
	
	iMemory16 = piMemory \ 16
	ReDim avBlock(iMemory)
	For iCount = 0 To iMemory16
		avBlock(iCount) = 0
	Next
	msgbox "3"
	MsgBox iCount
	Erase avBlock
End Sub